//+------------------------------------------------------------------+
//|                                                AlsThreeDucks.mq4 |
//|                                                  Allan Stevenson |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Allan Stevenson"
#property link      ""

//---- input parameters
extern double    lots=0.1;
extern double    takeProfit=30.0;
extern double    trailingStop=20.0;
extern double    stopLoss=30.0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//----
   //set some values
  double H4_60sma, H1_60sma, M5_60sma, lastH4Close, lastH1Close, lastM5Close, lastM5Open, currentVolume, lastVolume;
  H4_60sma=iMA(NULL, PERIOD_H4, 60, 0, MODE_SMA, PRICE_CLOSE, 0);
  H1_60sma=iMA(NULL, PERIOD_H1, 60, 0, MODE_SMA, PRICE_CLOSE, 0);
  M5_60sma=iMA(NULL, PERIOD_M5, 60, 0, MODE_SMA, PRICE_CLOSE, 0);
  
  lastH4Close=iClose(NULL, PERIOD_H4, 0);
  lastH1Close=iClose(NULL, PERIOD_H1, 0);
  lastM5Close= iClose(NULL, PERIOD_M5,0);
  lastM5Open=iOpen(NULL, PERIOD_M5, 0);
 
  currentVolume=iVolume(NULL, PERIOD_M5, 0);
  lastVolume=iVolume(NULL, PERIOD_M5, 1);
  
  
  int total  = OrdersTotal(); 
  if(total < 1)
  {
      if (lastH4Close>H4_60sma && lastH1Close>H1_60sma) //maybe we'll go long
      {   
          if (lastM5Close>M5_60sma) //let's do some final decision making
          {  
             if (lastM5Open>M5_60sma) //if open is greater than close 
             {
               // if (currentVolume-lastVolume>0)//if volume is up let's buy
               // {
                   Print("Buy \n H4_60sma "+H4_60sma+" last H4 close is "+lastH4Close+"\n H1_60sma "+H1_60sma+" last H1 close is "+lastH1Close+"\n M5_60sma "+M5_60sma+" last M1 close is "+lastM5Close);
                   int  res=OrderSend(Symbol(),OP_BUY, 0.1,Ask,3,Ask-stopLoss *Point,Ask+takeProfit*Point,"",0,0,Green);
               // }
             }
          }
      }
      else
      {
          if (lastH4Close<H4_60sma && lastH1Close<H1_60sma) //maybe we'll go short
          {   
             if (lastM5Close<M5_60sma) //let's do some final decision making
             {  
                if (lastM5Open<M5_60sma) //if open is lower than close 
                {
                 //  if (currentVolume-lastVolume>0)//if volume is up let's sell
                  // {
                       Print("Sell \n H4_60sma "+H4_60sma+" last H4 close is "+lastH4Close+"\n H1_60sma "+H1_60sma+" last H1 close is "+lastH1Close+"\n M5_60sma "+M5_60sma+" last M1 close is "+lastM5Close);
                      int  res2=OrderSend(Symbol(),OP_SELL, 0.1,Bid,3,Bid+stopLoss*Point,Bid-takeProfit*Point,"",0,0,Red);
                  // }
                }
             }
          }
      }
 }

for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
               // should it be closed?
               if(lastM5Close<=M5_60sma)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue); // close position
                 return(0); // exit
                }
            // check for trailing stop
            /*if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }*/
           }
         else // go to short position
           {
            // should it be closed?
            if(lastM5Close>=M5_60sma)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Blue); // close position
               return(0); // exit
              }
            // check for trailing stop
           /* if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }*/
           }
        }
     }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+